Index: /trunk/seguranca/ExpressoCertMail/src/br/gov/serpro/js/ParamReaderThread.java
===================================================================
--- /trunk/seguranca/ExpressoCertMail/src/br/gov/serpro/js/ParamReaderThread.java	(revision 1035)
+++ /trunk/seguranca/ExpressoCertMail/src/br/gov/serpro/js/ParamReaderThread.java	(revision 1035)
@@ -0,0 +1,216 @@
+package br.gov.serpro.js;
+
+import java.awt.Frame;
+import java.io.IOException;
+import java.security.GeneralSecurityException;
+import java.security.ProviderException;
+import java.util.Map;
+
+import javax.mail.MessagingException;
+
+import org.bouncycastle.mail.smime.SMIMEException;
+import br.gov.serpro.cert.DigitalCertificate;
+import br.gov.serpro.setup.Setup;
+import br.gov.serpro.ui.DialogBuilder;
+import br.gov.serpro.util.Base64Utils;
+
+import netscape.javascript.JSObject;
+import org.bouncycastle.cms.CMSException;
+
+
+public class ParamReaderThread extends Thread {
+
+	JSObject page;
+	Javascript2AppletPassingData data;
+	Setup setup;
+	Frame parentFrame;
+
+	public ParamReaderThread(JSObject page, Javascript2AppletPassingData data, Setup setup, Frame parent) {
+	//public ParamReaderThread(JSObject page, Javascript2AppletPassingData data, Setup setup) {
+		super();
+		this.page = page;
+		this.data = data;
+		this.setup = setup;
+		this.parentFrame = parent;
+	}
+
+	@Override
+	public void run() {
+		// TODO Stub de método gerado automaticamente
+		super.run();
+
+        while (true){
+			if (setup.getParameter("debug").equalsIgnoreCase("true")){
+				System.out.println("Classe ParamReaderThread: pegando resultado.");
+			}
+            
+            // processa o smime. Método sign implementado na classe DigitalCertificate
+            String smime = null;
+            DigitalCertificate dc = null;
+
+            try {
+
+                //Map<String, String> parsedData = parseData(resultado);
+                Map<String, String> parsedData = data.getMap();
+
+                dc = new DigitalCertificate(this.parentFrame, this.setup);
+                dc.init();
+
+                // Testa a operação e se for
+                if (parsedData.get("operation").equals("sign")){
+
+                    smime = dc.signMail(parsedData);
+                    if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                        System.out.println("\nMensagem assinada: " + smime);
+                    }
+
+                }
+              else if (parsedData.get("operation").equals("decript")){
+                    String decryptedMsg = dc.cipherMail(parsedData);
+                    if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                        System.out.println("Mensagem decifrada: " + decryptedMsg);
+                    }
+                    if (decryptedMsg == null){
+                        smime = null;
+                    } else {
+                        smime = Base64Utils.base64Encode(decryptedMsg.getBytes());
+                    }
+                    
+                }
+                else {
+                    throw new UnsupportedOperationException("Operation not supported: " + parsedData.get("operation"));
+                    // Lança
+                }
+
+                // Retorna para a página
+                // se smime = null, a assinatura não funcionou
+                if (smime != null){
+                    page.call("appletReturn", new String[] {smime, parsedData.get("ID"), parsedData.get("operation"), parsedData.get("folder")});
+                }
+
+            } catch (IOException e) {
+                //DialogBuilder.showMessageDialog(this.parentFrame, "Não foi possível carregar Token/SmartCard: senha incorreta", this.setup);
+                DialogBuilder.showMessageDialog(this.parentFrame, setup.getLang("ExpressoCertMailMessages", "ParamReaderThread001"), this.setup);
+                //JOptionPane.showMessageDialog(this.parentFrame, "Não foi possível carregar Token/SmartCard: senha incorreta",
+                //        "Aviso", JOptionPane.INFORMATION_MESSAGE);
+                if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                    e.printStackTrace();
+                }
+            } catch (GeneralSecurityException e) {
+                if (e.getCause() != null){
+                    DialogBuilder.showMessageDialog(this.parentFrame, "GeneralSecurityException: " + e.getCause().getMessage(), this.setup);
+                    //JOptionPane.showMessageDialog(this.parentFrame, "GeneralSecurityException: " + e.getCause().getMessage(),
+                    //        "Aviso", JOptionPane.INFORMATION_MESSAGE);
+                }
+                else {
+                    DialogBuilder.showMessageDialog(this.parentFrame, "GeneralSecurityException: " + e.getMessage(), this.setup);
+                    //JOptionPane.showMessageDialog(this.parentFrame, "GeneralSecurityException: " + e.getMessage(),
+                    //        "Aviso", JOptionPane.INFORMATION_MESSAGE);
+                }
+                if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                    e.printStackTrace();
+                }
+            } catch (SMIMEException e) {
+                //DialogBuilder.showMessageDialog(this.parentFrame, "Erro no processamento da assinatura: " + e.getMessage(), this.setup);
+                DialogBuilder.showMessageDialog(this.parentFrame, setup.getLang("ExpressoCertMailMessages", "ParamReaderThread002"), this.setup);
+                //JOptionPane.showMessageDialog(this.parentFrame, "Erro no processamento da assinatura: " + e.getMessage(),
+                //        "Aviso", JOptionPane.INFORMATION_MESSAGE);
+                if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                    e.printStackTrace();
+                }
+            } catch (MessagingException e) {
+                //DialogBuilder.showMessageDialog(this.parentFrame, "Erro no processamento da mensagem: " + e.getMessage(), this.setup);
+                DialogBuilder.showMessageDialog(this.parentFrame, setup.getLang("ExpressoCertMailMessages", "ParamReaderThread003"), this.setup);
+                //JOptionPane.showMessageDialog(this.parentFrame, "Erro no processamento da mensagem: " + e.getMessage(),
+                //        "Aviso", JOptionPane.INFORMATION_MESSAGE);
+                if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                    e.printStackTrace();
+                }
+            }
+            catch (CMSException e){
+                //DialogBuilder.showMessageDialog(this.parentFrame, "Erro ao decifrar mensagem: Detectado problema na integridade da mensagem cifrada!", this.setup);
+                DialogBuilder.showMessageDialog(this.parentFrame, setup.getLang("ExpressoCertMailMessages", "ParamReaderThread004"), this.setup);
+                //if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                Throwable cause = e.getCause();
+                System.out.println(e.getClass().getCanonicalName() + ": " + e.getMessage());
+                if (cause != null){
+                    System.out.println(cause.getClass().getCanonicalName() + ": " + cause.getMessage());
+                }
+                e.printStackTrace();
+                //}
+            }
+            catch (ProviderException e){
+                //DialogBuilder.showMessageDialog(this.parentFrame, "Problema no acesso às informações do Token: " + e.getMessage(), this.setup);
+                DialogBuilder.showMessageDialog(this.parentFrame, setup.getLang("ExpressoCertMailMessages", "ParamReaderThread005"), this.setup);
+                //JOptionPane.showMessageDialog(this.parentFrame, "Problema no acesso às informações do Token: " + e.getMessage(),
+                //        "Aviso", JOptionPane.INFORMATION_MESSAGE);
+                if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                    e.printStackTrace();
+                }
+            }
+            catch (UnsupportedOperationException e){
+                // DialogBuilder.showMessageDialog(this.parentFrame, e.getMessage());
+                if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                    e.printStackTrace();
+                }
+            }
+            catch (IllegalArgumentException e){
+                //DialogBuilder.showMessageDialog(this.parentFrame, e.getMessage());
+                if (setup.getParameter("debug").equalsIgnoreCase("true")) {
+                    e.printStackTrace();
+                }
+            }
+            catch (InterruptedException e){
+                if (setup.getParameter("debug").equalsIgnoreCase("true")){
+                    System.out.println("Classe ParamReaderThread: Thread has been interrupted! Break.");
+                    e.printStackTrace();
+                }
+                break;
+            }
+
+			dc.destroy();
+			dc = null;
+			System.gc();
+            Thread.yield();
+
+        }
+	}
+
+	//TODO: Documentar o que recebe!!!
+	/*private Map<String, String> parseData(String expressoMailData){
+
+        if ((expressoMailData == null) || (expressoMailData.length() == 0)){
+            throw new IllegalArgumentException("Can't unserialize NULL or empty value!");
+        }
+
+		Map<String, String> parsedData = new HashMap<String, String> ();
+		//Map<String, String> headersData = new HashMap<String, String>();
+
+		for (String paramsArray : expressoMailData.split(";")){
+
+			if (this.setup.getParameter("debug").equalsIgnoreCase("true")){
+				System.out.println("sendo parseado: " + paramsArray);
+			}
+			String[] param = paramsArray.split(":");
+			//if (temp[0].equals("headers")){
+			//	String[] headersArray = new String(Base64Utils.base64Decode(temp[1])).split(";");
+			//	for (String header: headersArray){
+			//		String[] keyValueType = header.split(":");
+			//		headersData.put(keyValueType[0], keyValueType[1]);
+			//	}
+			//}
+			//else{
+			parsedData.put(param[0], new String(Base64Utils.base64Decode(param[1])));
+			//}
+
+		}
+
+		return parsedData;
+	}
+
+	static private String processReturn(Map smimeData){
+
+		return new String();
+	}
+*/
+}
Index: /trunk/seguranca/ExpressoCertMail/src/br/gov/serpro/js/Javascript2AppletPassingData.java
===================================================================
--- /trunk/seguranca/ExpressoCertMail/src/br/gov/serpro/js/Javascript2AppletPassingData.java	(revision 1035)
+++ /trunk/seguranca/ExpressoCertMail/src/br/gov/serpro/js/Javascript2AppletPassingData.java	(revision 1035)
@@ -0,0 +1,67 @@
+package br.gov.serpro.js;
+
+import java.util.HashMap;
+import java.util.Map;
+
+public class Javascript2AppletPassingData {
+
+	private boolean locked = true;
+	private String data = null;
+    private Map<String, String> mapData = null;
+
+	public synchronized String getData() throws InterruptedException{
+		if (isLocked()){
+			data = null;
+            wait();
+		}
+		lock();
+		//notifyAll();
+		return this.data;
+	}
+
+	public synchronized Map<String, String> getMap() throws InterruptedException{
+		if (isLocked()){
+			mapData = null;
+            wait();
+		}
+		lock();
+		//notifyAll();
+		return this.mapData;
+	}
+
+	public synchronized void setData(String data){
+		//flag = true;
+		this.data = data;
+		unlock();
+	}
+
+    public synchronized void setData(String operation, String id, String body){
+		//flag = true;
+        if (this.mapData == null) {
+            this.mapData = new HashMap<String, String>();
+        }
+		this.mapData.put("operation", operation);
+        this.mapData.put("ID", id);
+        this.mapData.put("body", body);
+		unlock();
+	}
+
+    public synchronized void setData(String operation, String id, String body, String folder){
+        this.mapData = new HashMap<String, String>();
+        this.mapData.put("folder", folder);
+        this.setData(operation, id, body);
+    }
+
+	public synchronized void unlock(){
+		locked = false;
+		notifyAll();
+	}
+
+	private synchronized void lock(){
+		locked = true;
+	}
+
+	public synchronized boolean isLocked(){
+		return locked;
+	}
+}
Index: /trunk/seguranca/ExpressoCertMail/src/ExpressoSmimeApplet.java
===================================================================
--- /trunk/seguranca/ExpressoCertMail/src/ExpressoSmimeApplet.java	(revision 1035)
+++ /trunk/seguranca/ExpressoCertMail/src/ExpressoSmimeApplet.java	(revision 1035)
@@ -0,0 +1,90 @@
+import java.awt.Frame;
+
+import javax.swing.JApplet;
+import javax.swing.SwingUtilities;
+
+import netscape.javascript.JSObject;
+
+import br.gov.serpro.js.Javascript2AppletPassingData;
+import br.gov.serpro.js.ParamReaderThread;
+import br.gov.serpro.setup.Setup;
+
+//TODO: Logs de depuração e interface para usuário reportar problemas.
+
+public class ExpressoSmimeApplet extends JApplet {
+
+	/**
+	 * Variáveis de instância
+	 */
+	private Setup setup;
+	private Javascript2AppletPassingData dataReader;
+	private Thread paramReaderThread;
+
+	/**
+	 * Variáveis de classe
+	 */
+	private static final long serialVersionUID = 4797603392324194391L;
+
+	@Override
+	public void init() {
+		super.init();
+		this.setSize(1, 1);
+		this.setup = new Setup(this);
+        this.setup.addLanguageResource("ExpressoCertMailMessages");
+		this.dataReader = new Javascript2AppletPassingData();
+		// this.paramReaderThread = new ParamReaderThread(JSObject.getWindow(this), dataReader, setup);
+		this.paramReaderThread = new ParamReaderThread(JSObject.getWindow(this), dataReader,
+				setup, (Frame) SwingUtilities.getAncestorOfClass(Frame.class, this));
+		this.paramReaderThread.start();
+	}
+
+	@Override
+    /**
+     * Retorna Informações sobre os parâmetros que essa applet aceita
+     * @author Mário César Kolling <mario.kolling@serpro.gov.br>
+     * @return String[][] Uma matriz de Strings relacionando cada parâmetro à sua descrição
+     */
+	public String[][] getParameterInfo() {
+		return setup.getParameterInfo();
+	}
+
+	@Override
+	public void start() {
+		super.start();
+
+	}
+
+	@Override
+	public void stop() {
+		super.stop();
+		//dataReader.unlock();
+
+        if (this.paramReaderThread.isAlive()){
+            if (setup.getParameter("debug").equalsIgnoreCase("true")){
+                System.out.println("Interrompendo Applet paramReaderThread");
+            }
+            this.paramReaderThread.interrupt();
+        }
+	}
+
+	/**
+     * Método da Applet chamado pela página (js) ao assinar ou decifrar um e-mail
+	 * @param resultado Dados serializados passados pela Applet
+	 */
+	public void doButtonClickAction(String resultado){
+		dataReader.setData(resultado);
+		dataReader.unlock();
+		//return "cert";
+	}
+
+    public void doButtonClickAction(String operation, String id, String body){
+        dataReader.setData(operation, id, body);
+        //dataReader.unlock();
+    }
+
+    public void doButtonClickAction(String operation, String id, String body, String folder){
+        dataReader.setData(operation, id, body, folder);
+        //dataReader.unlock();
+    }
+
+}
Index: /trunk/seguranca/ExpressoCertMail/src/DataReader.java
===================================================================
--- /trunk/seguranca/ExpressoCertMail/src/DataReader.java	(revision 1035)
+++ /trunk/seguranca/ExpressoCertMail/src/DataReader.java	(revision 1035)
@@ -0,0 +1,33 @@
+
+public class DataReader {
+
+	private boolean flag = false;
+	private String resultado;
+
+	public synchronized String getResultado(){
+		lock();
+		//notifyAll();
+		return this.resultado;
+	}
+
+	public synchronized void setResultado(String resultado){
+		//flag = true;
+		this.resultado = resultado;
+	}
+
+	public synchronized void unlock(){
+		flag = true;
+		notifyAll();
+	}
+
+	private synchronized void lock(){
+		while (!flag){
+			try{
+				wait();
+			}
+			catch (InterruptedException e){}
+		}
+		flag = false;
+	}
+
+}
Index: /trunk/seguranca/captcha.php
===================================================================
--- /trunk/seguranca/captcha.php	(revision 1035)
+++ /trunk/seguranca/captcha.php	(revision 1035)
@@ -0,0 +1,115 @@
+<?php
+ /******************************************************************
+   Projectname:   CAPTCHA class
+   Version:       1.1
+   Author:        Pascal Rehfeldt <Pascal@Pascal-Rehfeldt.com>
+   Last modified: 15. March 2004
+   Copyright (C): 2003, 2004 Pascal Rehfeldt, all rights reserved
+
+   * GNU General Public License (Version 2, June 1991)
+   *
+   * This program is free software; you can redistribute
+   * it and/or modify it under the terms of the GNU
+   * General Public License as published by the Free
+   * Software Foundation; either version 2 of the License,
+   * or (at your option) any later version.
+   *
+   * This program is distributed in the hope that it will
+   * be useful, but WITHOUT ANY WARRANTY; without even the
+   * implied warranty of MERCHANTABILITY or FITNESS FOR A
+   * PARTICULAR PURPOSE. See the GNU General Public License
+   * for more details.
+
+   Description:
+   This class can generate CAPTCHAs, see README for more details!
+
+   Get the "Hurry up!" Font for the Captcha and
+   save it in the same directory as this file.
+
+   "Hurry up!" Font (c) by Andi
+   See http://www.1001fonts.com/font_details.html?font_id=2366
+  ******************************************************************/
+
+  class captcha
+  {
+
+    var $Length;
+    var $CaptchaString;
+    var $ImageType;
+    var $Font;
+    var $CharWidth;
+
+    function captcha ($length = 5, $type = 'png')
+    {
+      $this->Length    = $length;
+      $this->ImageType = $type;
+      $this->Font      = './hurryup.ttf';      
+      $this->CharWidth = 27;
+      $this->StringGen();
+    }
+
+    function Showcaptcha()
+    {
+      $this->SendHeader();
+      $this->MakeCaptcha();   
+    }
+
+    function StringGen ()
+    {
+      $uppercase  = range('A', 'Z');
+      $numeric    = range(0, 9);
+      $CharPool   = array_merge($uppercase, $numeric);
+      $PoolLength = count($CharPool) - 1;
+      for ($i = 0; $i < $this->Length; $i++)
+      {
+        $this->CaptchaString .= $CharPool[mt_rand(0, $PoolLength)];
+      }
+    }
+
+    function SendHeader ()
+    {
+      switch ($this->ImageType)
+      {
+        case 'jpeg': header('Content-type: image/jpeg'); break;
+        case 'png':  header('Content-type: image/png');  break;
+        default:     header('Content-type: image/png');  break;
+      }
+    }
+
+    function MakeCaptcha ()
+    {
+      $imagelength = $this->Length * $this->CharWidth + 16;
+      $imageheight = 37;
+      $image       = imagecreate($imagelength, $imageheight);
+      $bgcolor     = imagecolorallocate($image, 255, 255, 255);
+      $stringcolor = imagecolorallocate($image, 0, 0, 155);
+      $linecolor   = imagecolorallocate($image, 0, 0, 0);
+      imagettftext($image, 25, -4, 8, 25,
+                   $stringcolor,
+                   $this->Font,
+                   $this->CaptchaString);
+      switch ($this->ImageType)
+      {
+        case 'jpeg': imagejpeg($image); break;
+        case 'png':  imagepng($image);  break;
+        default:     imagepng($image);  break;
+      }
+    }
+
+    function GetCaptchaString ()
+    {
+      return $this->CaptchaString;
+    }
+    
+  }
+ 
+ // ************  Fim da Classe  *************************
+ 
+ 
+  //Cria o CAPTCHA( gera o string e a imagem ...
+  $GLOBALS['captcha'] = new captcha;
+  // Guarda o string do captcha na session...
+  $_SESSION['CAPTCHAString'] = $GLOBALS['captcha'] ->GetCaptchaString();
+  // Vai exibir a imagem do captcha...
+  $GLOBALS['captcha'] ->Showcaptcha();
+?>
Index: /trunk/seguranca/classes_BKP/Verifica_Certificado_conf.php
===================================================================
--- /trunk/seguranca/classes_BKP/Verifica_Certificado_conf.php	(revision 1035)
+++ /trunk/seguranca/classes_BKP/Verifica_Certificado_conf.php	(revision 1035)
@@ -0,0 +1,5 @@
+<?php
+$GLOBALS['dirtemp']  =   '/var/www/expresso/seguranca/temp'; 
+$GLOBALS['CAs']  =         '/var/www/expresso/seguranca/cas/todos.cer';
+$GLOBALS['CRLs']  =       '/var/www/expresso/seguranca/crls/'; 
+?>
Index: /trunk/seguranca/classes_BKP/CertificadoB.php
===================================================================
--- /trunk/seguranca/classes_BKP/CertificadoB.php	(revision 1035)
+++ /trunk/seguranca/classes_BKP/CertificadoB.php	(revision 1035)
@@ -0,0 +1,300 @@
+<?php
+require_once('funcoes_auxiliares.php');
+require_once('Verifica_Certificado_conf.php');
+require_once('Verifica_Certificado.php');
+
+//  Pre-requisito: A extensao openssl deve estar disponivel no PHP ....
+class certificadoB
+{
+
+  public $dados = array();        # Area para armazenar os dados recuperados do certificado.
+  public $apresentado =false;    # Deve ser testado para verificar se no certificado processado foi localizado o CPF
+  public $erros_ssl = array(); 
+  public $cert_assinante = '';	
+  public $msg_sem_assinatura = '';  #conteï¿œdo da mensagem sem assinatura, que retorna da funï¿œï¿œo verify do openssl
+  public $arquivos_para_deletar = array();
+  
+  public function __construct()
+  {
+    if(!extension_loaded('openssl'))
+    {
+      #PHP sem suporte ao openssl.....
+      return false;
+    }
+  }
+
+  public function __destruct()
+  {
+    #Remover arquivos temporarios.....	
+    deleta_arquivos_temporarios($this->arquivos_para_deletar);
+  }
+
+
+#--------------------------------------------------------------------------------------------------------------------------------------------------------
+#--------------------------------------------------------------------------------------------------------------------------------------------------------
+# Recupera dados de um certificado no formato pem 
+#--------------------------------------------------------------------------------------------------------------------------------------------------------    
+  function certificado($certificado_pem)
+  {		
+  
+    if (!$certificado_pem) 
+    {
+        $this->apresentado = False;
+        return False;    # Sem parametro ...
+    }
+
+   $this->dados = recupera_dados_do_ceritificado_digital($certificado_pem);
+   
+  # Certificado foi processado, as informacoes obtidas estao em $this->dados. 
+
+  $this->apresentado = true;  
+
+  }
+
+#--------------------------------------------------------------------------------------------------------------------------------------------------------
+#--------------------------------------------------------------------------------------------------------------------------------------------------------
+# Encriptar uma msg($m) para o(s) destinatario(s) $c(array com certificados)com os headers passados em $h.
+#--------------------------------------------------------------------------------------------------------------------------------------------------------    
+	public function encriptar($m,$c,$h)
+	{
+		if($m == '')	return false;
+			
+		if(!is_array($c))	return false;
+		
+		$aux = count($c);
+		if($aux < 1)	return false;		
+
+		if(!is_array($h) )	return false;
+		
+		# Tem de verificar todos os certificados que serao utilizados para criptografar a msg..
+		# Inserir a rotina aqui....
+		
+		$m_arquivo_temporario = gera_nome_arquivo_temporario(&$this->arquivos_para_deletar);
+		//echo $m_arquivo_temporario.'<br>';
+
+		if(!grava_arquivo($m_arquivo_temporario,$m))
+		{
+			return false;
+		}
+
+		$enc_arquivo_temporario = gera_nome_arquivo_temporario(&$this->arquivos_para_deletar);
+		//echo $enc_arquivo_temporario.'<br>';
+		
+		// LIMPA ERROS ... Pode ser um problema para outras aplicacoes que usam openssl(fonte de erros unica).
+		while ($erro = openssl_error_string()); //  Limpa buffer de erros anteriores......
+		$this->erros_ssl = array();
+		$resultado = openssl_pkcs7_encrypt($m_arquivo_temporario,$enc_arquivo_temporario,$c,$h);
+		if(!$resultado)
+		{
+			// Guarda msgs de erro ...
+			while ($erro = openssl_error_string()) 
+			{ 
+				$this->erros_ssl[] = $erro;
+			}
+			deleta_arquivos_temporarios($this->arquivos_para_deletar);
+			$this->arquivos_para_deletar = array();
+			return false;
+		}
+                # Recupera a msg criptada......		
+		$retorno = file_get_contents($enc_arquivo_temporario);
+		//$aux = explode(chr(0x0A),file_get_contents($enc_arquivo_temporario));
+		//$retorno='';
+		/*
+		$flag = false;
+		for ($i = 0; $i < count($aux); $i++) 
+		{
+			if(!$aux[$i]) 
+			{
+				if(!$flag)
+					{
+						//$retorno .= '-----BEGIN PKCS7-----'.chr(0x0A);
+						$flag = true;
+					}
+			}
+			else
+			{
+				$retorno .= $aux[$i].chr(0x0A);
+			}
+		}
+		//$retorno .= '-----END PKCS7-----'.chr(0x0A);
+		*/
+		deleta_arquivos_temporarios($this->arquivos_para_deletar);
+		$this->arquivos_para_deletar = array();
+		
+		return $retorno;
+	}
+
+#--------------------------------------------------------------------------------------------------------------------------------------------------------
+#--------------------------------------------------------------------------------------------------------------------------------------------------------
+# Verifica uma msg($m) assinada... 
+#--------------------------------------------------------------------------------------------------------------------------------------------------------    
+	public function verificar($m)
+	{
+		if($m == '') return false;
+
+		$m_arquivo_temporario = gera_nome_arquivo_temporario(&$this->arquivos_para_deletar);
+
+		if(!grava_arquivo($m_arquivo_temporario,$m))
+		{
+			deleta_arquivos_temporarios($this->arquivos_para_deletar);
+			$this->arquivos_para_deletar = array();
+			return false;
+		}
+
+		$vrf_cert_arquivo_temporario = gera_nome_arquivo_temporario(&$this->arquivos_para_deletar);
+	
+		$vrf_msg_arquivo_temporario = gera_nome_arquivo_temporario(&$this->arquivos_para_deletar);
+	
+		// LIMPA ERROS ... Pode ser um problema para outras aplicacoes que usam openssl(fonte de erros unica).
+		while ($erro = openssl_error_string()); //  Limpa buffer de erros anteriores......
+		$this->erros_ssl = array();
+		$resultado = openssl_pkcs7_verify($m_arquivo_temporario,0, $vrf_cert_arquivo_temporario,array($GLOBALS['CAs']),$GLOBALS['CAs'],$vrf_msg_arquivo_temporario);
+                $retorno = true; 
+		if(!$resultado)
+		{
+		        # Indica ocorrencia de erro ... 
+		        $retorno = false;
+			// Guarda msgs de erro ...
+			while ($erro = openssl_error_string()) 
+			{ 
+				$this->erros_ssl[] = $erro;
+			}
+			# Reexecuta o comando com um nivel menor de criticas.
+			$this->cert_assinante = $this->extrai_certificado_da_msg_assinada($m);
+			if(!$this->cert_assinante)
+			{
+				# Se nao foi possivel obter o certificado retorna com falso .....
+				deleta_arquivos_temporarios($this->arquivos_para_deletar);
+				$this->arquivos_para_deletar = array();
+				return false;
+			}
+		}
+		else
+		{
+			# Guarda o certificado usado para assinar a msg
+			$this->cert_assinante  =   file_get_contents($vrf_cert_arquivo_temporario);
+                 }
+		 
+		$this->msg_sem_assinatura =  file_get_contents($vrf_msg_arquivo_temporario);
+
+		$this->certificado($this->cert_assinante);
+
+		if (!$this->apresentado)
+		{
+			$this->erros_ssl[] = 'Certificado da Msg nao pode ser tratado.';
+			$retorno = false;
+		}
+		else
+		{
+			while ($erro = openssl_error_string()); //  Limpa buffer de erros anteriores......
+			# Certificado poderia ter assinado um email?? 
+			if(!openssl_x509_checkpurpose($vrf_cert_arquivo_temporario,X509_PURPOSE_SMIME_SIGN))
+			{
+				$this->erros_ssl[] = 'Certificado nao poderia ter sido utilizado para assinar email.';
+				while ($erro = openssl_error_string()) 
+					{ 
+						$this->erros_ssl[] = $erro;
+					}
+				$retorno = false;
+			}
+			// Isto esta codificado assim antecipando nova versao do parseador....
+			$this->dados['KEYUSAGE']['digitalSignature'] =TRUE;
+			$this->dados['EXTKEYUSAGE']['emailProtection'] = '1.3.6.1.5.5.7.3.4';
+
+			//testa se certificado revogado
+			$revogado = new Verifica_Certificado($this->dados,$this->cert_assinante);
+			$this->dados['REVOGADO'] = false;
+  			if(!$revogado->status){
+   				$this->erros_ssl[] = $revogado->msgerro;
+				foreach ($revogado->erros_ssl as $item)
+					{
+						$this->erros_ssl[] = $item;
+					}
+				if ($revogado->revogado)
+					$this->dados['REVOGADO'] = true;
+   				$retorno  = false;
+   			}
+		}
+
+		deleta_arquivos_temporarios($this->arquivos_para_deletar);
+		$this->arquivos_para_deletar = array();	
+		return $retorno;
+	}	
+
+
+	public function extrai_certificado_da_msg_assinada($m)
+	{
+	        $retorno = false;
+		
+	        if(!$m)
+		{
+			return $retorno;
+		}
+
+		$m_arquivo_temporario = gera_nome_arquivo_temporario(&$this->arquivos_para_deletar);
+
+		if(!grava_arquivo($m_arquivo_temporario,$m))
+		{
+			deleta_arquivos_temporarios($this->arquivos_para_deletar);
+			$this->arquivos_para_deletar = array();
+			return $retorno;
+		}
+		
+		$w='';
+		$saida = array();
+		$w = exec('cat ' . $m_arquivo_temporario . ' | openssl smime -pk7out | openssl pkcs7 -print_certs',$saida);
+		if(!$w=='')
+		{
+			deleta_arquivos_temporarios($this->arquivos_para_deletar);
+			$this->arquivos_para_deletar = array();
+			return $retorno;
+		}
+		
+		$aux1 = '';
+                // gera uma unica string com o conteudo retornado pelo comando...
+		foreach($saida as $linha)
+		{
+			$aux1 .= $linha.chr(0x0A);
+		}
+
+                // cria um array com os certificados retornados..
+		$aux2 = explode('-----BEGIN CERTIFICATE-----',$aux1);
+		array_shift($aux2);
+
+		// isolando certificados..
+		$aux5 = array();
+		foreach($aux2 as $item)
+		{
+			$aux3 = explode('-----END CERTIFICATE-----',$item);
+			$aux4 = '-----BEGIN CERTIFICATE-----' . $aux3[0] . '-----END CERTIFICATE-----';
+			$aux5[] = $aux4;
+		}
+
+
+		// Gera array com as CAs que assinaram os certificados encontrados na msg....
+		$aux5_ACs = array();		
+		foreach($aux5 as $item)
+		{
+			$cert = openssl_x509_parse($item);
+			$aux5_ACs[$cert[issuer][CN]] =  $cert[issuer][CN];
+		}
+
+		// Verifica qual certificado tem no subject um CN que nao he uma CA.
+		foreach($aux5 as $item)
+		{
+			$cert = openssl_x509_parse($item);
+			if(!$aux5_ACs[$cert[subject][CN]])
+				{
+					$retorno = $item;
+					break;
+				}
+		}
+		
+		deleta_arquivos_temporarios($this->arquivos_para_deletar);
+		$this->arquivos_para_deletar = array();
+		
+		return $retorno;
+	}
+}
+
+?>
